//attributeWindow.cpp
//Copyright © 1998, Paul Yu 

#include "attributeWindow.h"
#include "listView.h"
#include "navView.h"
#include "message_protocols.h"
#include "addonManager.h"

attributeWindow::attributeWindow() : 
	BWindow(BRect(100,100,200,800), "", B_TITLED_WINDOW_LOOK, B_MODAL_SUBSET_WINDOW_FEEL, B_NOT_RESIZABLE)
{
	/*	*/
}

attributeWindow::~attributeWindow()
{
	/*	*/
}

void attributeWindow::MessageReceived(BMessage *msg)
{
	switch(msg->what)
	{
		case B_OK:
		{
			BMessenger messenger(mEntityWindow);
			mReply.what = UPDATE;	
			mListView->GetSelection(&mReply);			
			messenger.SendMessage(&mReply);
			Quit();
		}
		break;
		
		case B_CANCEL:
		{
			Quit();
		}
		break;

		case SET_CONTEXT:
		{
			BWindow *ew;

			if ((msg->FindPointer("add-on_manager", (void **)&mAddons) < B_OK) ||
				(msg->FindPointer("editor_window", (void **)&ew) < B_OK) ||
				(msg->FindPointer("entity_window", (void **)&mEntityWindow) < B_OK) ||
				(msg->HasString("type") == false))
					Quit();

			AddToSubset(ew);
			mReply.AddString("type", msg->FindString("type"));		
			
			Show();
		}
		break;	
	
		default:
			BWindow::MessageReceived(msg);
	}
}

void attributeWindow::Show()
{
	const char *attribute;
	mListView = new listView();
	int32 i = 0;

	mListView->SetListType(B_MULTIPLE_SELECTION_LIST);
	if (strcmp(mReply.FindString("type"), "behaviours") == 0)
	{
		//Behaviours
		SetTitle("Add Behaviours");
		mListView->SetListTitle("Behaviours");

		while((attribute = mAddons->GetBehaviour(i++)) != NULL)
		{
			mListView->AddItem(attribute);
		}
		AddChild(mListView);
	}
	else if (strcmp(mReply.FindString("type"), "visuals") == 0)
	{
		//Visuals
		SetTitle("Add Visual Attributes");
		mListView->SetListTitle("Visual Attributes");

		while((attribute = mAddons->GetVisual(i++)) != NULL)
		{
			mListView->AddItem(attribute);
		}
		AddChild(mListView);
	}
	else if (strcmp(mReply.FindString("type"), "initialisers") == 0)
	{
		//Initialisers
		SetTitle("Add Initialisers");
		mListView->SetListTitle("Initialisers");

		while((attribute = mAddons->GetInitialiser(i++)) != NULL)
		{
			mListView->AddItem(attribute);
		}
		AddChild(mListView);
	}
	else
		Quit();

	//Navigation
	AddChild(new navView());

	BWindow::Show();
}
